CoCoALib - Slug #967

Improve saturate
10 Nov 2016 09:20 - Anna Maria Bigatti

Status: Resolved Start date: 10 Nov 2016
Priority: Normal Due date:

Assignee: Anna Maria Bigatti % Done: 70%
Category: Improving Estimated time: 5.00 hours
Target version: CoCoALib-0.99880 Spent time: 4.85 hours

Description

saturate is slow (naive algorithm: repeated colon).
Improve it.

Related issues:

Related to CoCoA-5 - Slug #948: radical is slow (compared to singular) on the... Closed 18 Oct 2016
Related to CoCoALib - Feature #1619: Make saturate available in CoCoALib Closed 15 Oct 2021
Related to CoCoALib - Bug #1790: saturate with zero ideals Closed 13 Mar 2024
History

#1 - 10 Nov 2016 09:21 - Anna Maria Bigatti

- Related to Slug #948: radical is slow (compared to singular) on these examples added

#2 - 10 Nov 2016 09:21 - Anna Maria Bigatti

- Related to Support #942: Which names to use? Intersection/saturation vs intersect/saturate added

#3 - 10 Nov 2016 11:59 - Anna Maria Bigatti

- Description updated

| implemented another naive algorithm (elim(h, 1+(f*h-1))), but seems even worse.

#4 - 10 Nov 2016 12:00 - Anna Maria Bigatti
- % Done changed from 0 to 20

#5 - 10 Nov 2016 16:54 - Anna Maria Bigatti
- % Done changed from 20 to 30

| have modified ComputeSaturation using the factorization (repeats saturation on the factors).

| don't know if that's generally better or not, it also depends on the cost of the factorization.

| worked on this example coming from radical: here the polynomial is actually a product of linear forms and the computation goes from 1600 to <10
seconds

use QQ[c[0..19171;

L :=[

c[l]*c[6]*c[13] +c[1l]1*c[8]*c[1ll] -c[1l]*c[8]*c[13]1*c[18] -c[l]1*c[9]*c[13]"2 —-c[1l]*c[12] -c[1]*c[13]1*c[1l9] +c[1l]
*c[14]*c[18] +c[l]*c[l6] -c[l]*c[18]"2 +c[3]1*c[6]*c[11l] -c[3]*c[6]1*c[13]1*c[18] -c[3]*c[7]*c[13]1"2 -c[3]*c[8]*c
[11]1*c[18] +c[3]*c[8]1*c[13]172*c[19] -c[3]1*c[8]*c[13]*c[16] +c[3]*c[8]1*c[l3]*c[18]"2 -2*c[3]1*c[9]1*c[1l1l]*c[13] +
c[31*c[9]*c[13]1"2*c[14] +c[3]*c[9]1*c[13]1"2*c[18] -c[3]1*c[10] -c[3]1*c[11]*c[19] +c[3]1*c[l2]*c[18] -c[3]1*c[1l3]*c
[17] +2*c[3]1*c[13]1*c[18]1*c[19] +c[3]1*c[l4]1*c[l6] —-c[3]1*c[1l4]1*c[18]1"2 -2*c[3]*c[l6]*c[1l8] +c[3]1*c[1l8]1"3,
c[l]1*c[7]*c[13] -c[1l]1*c[8]1*c[13]1*c[19] +c[l]*c[9]1*c[1l1l] -c[l]1*c[9]1*c[13]*c[14] +c[l]1*c[l7] -c[l]l*c[1l8]*c[19] +
c[3]1*c[5]1*c[13] -c[31*c[6]1*c[13]1*c[19] +c[31*c[7]1*c[ll] —-c[3]1*c[7]1*c[13]1*c[1l4] -c[3]1*c[8]*c[11]1*c[19] +c[3]1*c|
8]1*c[13]*c[14]*c[19] -c[3]*c[8]1*c[13]1*c[17] +c[3]*c[8]*c[13]1*c[18]*c[19] -c[3]*c[9]*c[1l1l]*c[1l4] -c[3]1*c[9]*c[1
21*c[13] +c[31*c[9]1*c[13]172*c[19] +c[3]1*c[9]*c[13]*c[14]1"2 +c[3]*c[13]1*c[19]1"2 +c[3]1*c[1l5] -c[3]1*c[l6]*c[19] -
c[3]1*c[1l7]*c[18] +c[3]1*c[l8]"2*c[19],

c[l]*c[6]*c[11l] -c[l]1*c[8]*c[13]1*c[16] -c[l]1*c[9]*c[1l1]*c[13] —-c[1]1*c[10] -c[1l]*c[1l1]*c[19] +c[l]*c[l4]*c[l6]
—c[1l]*c[16]*c[18] -c[3]1*c[6]1*c[1l3]1*c[16] -c[3]*c[7]1*c[ll]*c[13] +c[3]1*c[8]*c[11l]*c[13]1*c[1l9] -c[3]1*c[8]*c[1l1l]~*
c[16] +c[31*c[8]*c[1l3]*c[l6]*c[18] —c[3]1*c[9]1*c[11]1"2 +c[3]1*c[9]*c[l1l]*c[13]*c[1l4] +c[3]1*c[9]1*c[13]1"2*c[l6] -cC
[3]1*c[11]*c[17] +c[3]*c[11]*c[18]1*c[19] +c[3]1*c[12]1*c[16] +c[3]1*c[13]1*c[16]*c[19] -c[3]*c[l4]*c[16]*c[18] -c[3
1*c[16]72 +c[3]*c[16]*c[18]"2,
cl[1]1*c[5]1*c[13] +c[l]*c[7]1*c[11] -c[1]*c[8]*c[13]*c[17] -c[l]*c[9]*c[12]*c[13] -c[1l]*c[12]*c[19] +c[l]*c[l4]*c
[17] +c[1]1*c[15] -c[1l]1*c[17]1*c[18] +c[3]1*c[5]1*c[11l] -c[3]1*c[6]1*c[13]*c[17] -c[3]1*c[7]1*c[1l2]*c[13] -c[3]*c[8]*c
[11]1*c[17] +c[3]1*c[8]1*c[12]*c[13]*c[19] -c[3]1*c[8]*c[13]*c[15] +c[3]*c[8]*c[13]*c[17]*c[18] -c[3]1*c[9]*c[10]*c
[13] -c[3]1*c[9]*c[11]*c[12] +c[3]*c[9]*c[12]*c[13]*c[14] +c[3]*c[9]*c[13]"2*c[17] -c[3]*c[10]*c[19] +c[3]*c[12
1*c[18]1*c[19] +c[3]1*c[13]1*c[17]1*c[19] +c[3]1*c[14]*c[15] -c[3]1*c[1l4]*c[17]*c[18] -c[3]1*c[15]*c[18] -c[3]*c[16]*
cl[17] +4c[3]1*c[17]1*c[18]"2,
cl[1]*c[5]*c[11] -c[1]1*c[8]*c[13]*c[15] -c[1]1*c[9]*c[10]*c[13] -c[1]*c[10]*c[19] +c[l]*c[14]*c[15] -c[1l]*c[15]*
cl[18] -c[31*c[6]*c[13]1*c[15] -c[3]1*c[7]1*c[10]1*c[13] +c[3]1*c[8]1*c[10]*c[13]1*c[19] -c[3]1*c[8]*c[1l1l]*c[15] +c[3]*
c[8]1*c[13]1*c[15]*c[18] -c[3]1*c[9]*c[10]*c[11] +c[3]1*c[9]*c[10]*c[13]*c[14] +c[3]1*c[9]*c[13]"2*c[15] -c[3]*c[10
]*c[17] +c[3]*c[10]*c[18]1*c[19] +c[3]*c[12]*c[15] +c[3]1*c[13]*c[15]*c[19] -c[3]*c[l4]*c[15]*c[18] -c[3]*c[15]*
c[16] +c[3]*c[1l5]*c[18]"2,
—c[6]*c[13] -c[8]1*c[11l] +c[8]1*c[13]1*c[18] +c[9]1*c[13]1"2 +c[12] +c[13]1*c[19] -c[14]*c[18] -c[16] +c[18]"2,
—c[7]1*c[13] +c[8]*c[13]*c[19] -c[9]*c[11l] +c[9]*c[13]*c[14] -c[17] +c[18]*c[19],
—c[6]1*c[11] +c[8]1*c[13]1*c[16] +c[9]*c[11]*c[13] +c[10] +c[11l]1*c[19] -c[1l4]*c[16] +c[l6]*c[18],
—c[5]1*c[13] -c[7]1*c[11] +c[8]1*c[13]1*c[17] +c[9]*c[12]*c[13] +c[12]*c[19] -c[l4]*c[17] -c[15] +c[l7]*c[18],
—c[5]1*c[11] +c[8]1*c[13]1*c[15] +c[9]1*c[10]*c[13] +c[10]1*c[19] -c[14]*c[15] +c[15]*c[18],
—c[1]1*c[7]1*c[13] +c[l]*c[8]*c[13]*c[19] -c[l]l*c[9]*c[11l] +c[1l]*c[9]*c[13]*c[14] -c[l]*c[1l7] +c[l]*c[18]*c[19]
—c[3]1*c[5]1*c[13] +c[3]*c[6]*c[13]*c[19] -c[3]*c[7]1*c[11l] +c[3]*c[7]*c[13]*c[14] +c[3]*c[8]*c[11]*c[19] -c[3]*c
[8]1*c[13]1*c[14]1*c[19] +c[3]1*c[8]1*c[13]1*c[17] -c[3]1*c[8]1*c[13]1*c[18]1*c[19] +c[3]1*c[9]*c[11]*c[14] +c[3]1*c[9]*cI
121*c[13] —c[31*c[9]1*c[13]172*c[19] —c[3]1*c[9]1*c[13]1*c[14]1"2 —c[3]1*c[13]1*c[19]1"2 —c[3]1*c[15] +c[3]1*c[16]*c[19]
+c[3]*c[17]1*c[18] -c[3]1*c[18]"2*c[19],
c[1]*c[5] —-c[l]*c[6]*c[19] -c[1ll*c[7]*c[14] +c[1l]*c[7]*c[18] +c[l]*c[8]*c[14]*c[19] -c[l]*c[8]*c[17] -c[l]*c[9
1*c[12] +c[1]1*c[9]1*c[13]1*c[19] +c[1l]1*c[9]*c[14]"2 —c[1l]*c[9]*c[14]*c[18] +c[1l]*c[9]*c[16] +c[l]*c[19]"2 —-c[3]*
c[5]1*c[14] +c[3]1*c[5]*c[18] +c[3]*c[6]*c[14]*c[19] -c[3]*c[6]*c[17] -c[3]1*c[7]1*c[12] +c[3]1*c[7]1*c[13]*c[19] +c
[3]1*c[7]*c[14]72 -c[3]*c[7]*c[14]*c[18] +c[3]1*c[7]1*c[16] +c[3]*c[8]*c[12]*c[19] -c[3]*c[8]*c[13]*c[19]"2 -c[3]
*c[8]1*c[14]172*c[19] +c[3]1*c[8]1*c[14]1*c[17] —c[3]1*c[8]1*c[15] —c[31*c[9]1*c[10] +c[3]1*c[9]1*c[11]1*c[19] +2*c[3]*cI
9]1*c[12]1*c[14] —c[3]1*c[9]1*c[12]1*c[18] —2*c[3]1*c[9]1*c[13]1*c[14]*c[19] +c[3]1*c[9]1*c[13]1*c[17] —c[3]1*c[9]*c[14]"3
+c[3]1*c[9]*c[14]72*c[18] -c[3]1*c[9]*c[14]*c[16] -c[3]1*c[14]*c[19]"2 +2*c[3]1*c[17]1*c[19] -c[3]1*c[18]*c[19]"2,
—c[1]1*c[7]1*c[11] +c[l]*c[8]*c[11]*c[19] +c[1]1*c[9]*c[11]*c[14] -c[l]*c[9]*c[11l]*c[18] +c[1l]*c[9]*c[13]*c[16] -
c[1]1*c[15] +c[1l]*c[16]*c[19] -c[3]1*c[5]*c[11] +c[3]*c[6]*c[11]*c[19] +c[3]*c[7]*c[1ll]*c[14] -c[3]*c[7]*c[ll]*c
[18] +c[3]*c[7]*c[13]*c[16] -c[3]*c[8]*c[11]*c[14]*c[19] +c[3]*c[8]*c[1l1l]*c[17] -c[3]1*c[8]*c[13]*c[16]*c[19] +
cl[31*c[9]1*c[11]1*c[12] -c[3]1*c[9]1*c[11]1*c[13]1*c[19] -c[3]1*c[9]*c[11]1*c[14]1"2 +c[3]1*c[9]*c[11]*c[14]*c[18] -c[3]
*c[9]*c[13]*c[14]*c[16] -c[3]1*c[11]*c[19]172 +c[3]*c[16]*c[17] -c[3]1*c[16]*c[18]*c[19],
c[1]1*c[5]1*c[18] -c[l]*c[6]*c[17] -c[1l]l*c[7]*c[12] +c[l]l*c[7]*c[16] +c[l]l*c[8]*c[12]*c[19] -c[1l]*c[8]*c[15] -c[
11*c[9]1*c[10] +c[l]l*c[9]*c[12]*c[14] -c[1l]1*c[9]1*c[12]*c[18] +c[l]*c[9]*c[13]*c[17] +c[l]l*c[17]1*c[19] -c[3]*c[5
]*c[12] +c[3]*c[5]*c[16] +c[3]*c[6]*c[12]*c[19] —-c[3]*c[6]*c[15] —c[3]*c[7]1*c[10] +c[3]*c[7]*c[12]*c[14] —c[3]
*c[71*c[12]1*c[18] +c[31*c[7]1*c[13]1*c[17] +c[31*c[8]1*c[10]1*c[19] -c[3]1*c[8]1*c[12]*c[14]1*c[19] +c[3]1*c[8]*c[12]*
c[17] -cl[31*c[8]1*c[13]1*c[17]1*c[19] +c[3]1*c[9]1*c[10]1*c[1l4] -c[3]1*c[9]1*c[10]*c[18] +c[3]1*c[9]1*c[1l1l]*c[17] +c[3]*
cl[9]1*c[12]172 -c[3]1*c[9]*c[12]*c[13]1*c[19] -c[3]1*c[9]*c[12]*c[14]72 +c[3]*c[9]*c[12]*c[14]*c[18] -c[3]*c[9]*c[1
2]1*c[16] —-c[3]1*c[9]*c[13]1*c[14]*c[17] +c[3]1*c[9]*c[13]*c[15] -c[3]1*c[12]1*c[19]172 +c[3]1*c[15]*c[19] +c[3]*c[17]
"2 —c[31*c[17]1*c[18]*c[19],
cl[1l]1*c[5]*c[16] -c[l]*c[6]*c[15] -c[1l]*c[7]1*c[10] +c[1]1*c[8]1*c[10]*c[19] +c[1l]*c[9]*c[10]*c[14] -c[l]*c[9]*c[1
0]1*c[18] +c[11*c[9]1*c[13]1*c[15] +c[1]1*c[15]1*c[19] —-c[3]1*c[5]1*c[10] +c[3]1*c[6]1*c[10]1*c[19] +c[3]1*c[7]1*c[10]*c[1
4] —c[31*c[7]1*c[10]1*c[18] +c[3]1*c[7]1*c[13]1*c[15] -c[3]1*c[8]1*c[10]*c[14]*c[19] +c[3]1*c[8]*c[10]*c[17] -c[3]*c[8
]*c[13]*c[15]*c[19] +c[3]1*c[9]*c[10]*c[12] -c[3]1*c[9]*c[10]*c[13]*c[19] -c[3]1*c[9]*c[10]*c[14]"2 +c[3]*c[9]*cI
10]*c[14]*c[18] -c[3]1*c[9]*c[10]*c[16] +c[3]*c[9]*c[11]*c[15] -c[3]1*c[9]*c[13]*c[14]*c[15] -c[3]*c[1l0]*c[19]"2
+c[3]1*c[15]1*c[17] -c[3]*c[15]*c[18]*c[19],
c[71*c[13] -c[8]1*c[13]1*c[19] +c[9]*c[11] -c[9]*c[13]1*c[14] +c[17] -c[18]*c[19],
—c[5] +c[6]1*c[19] +c[7]1*c[14] -c[7]1*c[18] -c[8]1*c[14]1*c[19] +c[8]*c[17] +c[9]*c[12] -c[9]*c[13]*c[19] -c[9]*c[
14172 +c[9]1*c[14]1*c[18] -c[9]1*c[16] -c[19]"2,
c[71*c[11] -c[8]1*c[11]1*c[19] -c[9]*c[11]*c[14] +c[9]*c[11]*c[18] -c[9]*c[13]*c[16] +c[15] -c[16]*c[19],
—c[5]1*c[18] +c[6]*c[17] +c[7]1*c[12] -c[7]1*c[16] -c[8]*c[12]*c[19] +c[8]*c[15] +c[9]*c[10] -c[9]*c[12]*c[14] +c
[9]1*c[12]*c[18] -c[9]*c[13]1*c[17] -c[17]1*c[19],

—c[5]*c[16] +c[6]*c[15] +c[7]1*c[10] -c[8]*c[10]*c[19] -c[9]*c[10]*c[14] +c[9]*c[10]*c[18] -c[9]*c[13]*c[1l5
1 -c[15]1*c[1911;

/**/ G := c[11]*c[1l4]*c[16]1"2*c[17]"2*c[18]"2*c([19]72 -c[11]*c[1l4]*c[15]*c[16]*c[17]*c([18]"3*c[19]"2 —-c[1l1l]*c|
14]*c[16]"3*c[17]*c[18]*c[19]"3 —-c[ll]*c[l4]*c[l6]"2*c[17]"3*c[18]*c[19] +c[ll]*c[1l4]*c[15]*c[l6]*c[17]"2*c[18
172*c[19] +2*c[11]1*c[14]*c[15]*c[16]"2*c[17]*c[18]*c[19]"2 —-c[11]*c[14]*c[15]"2*c[16]*c([17]*c[18]*c[19];

I := ideal(L);
CpuTime (); S := saturate(I, ideal(G)); TimeFrom(t);
#6 - 10 Nov 2016 17:01 - Anna Maria Bigatti

| see that there is an involutive saturation.
How does that work in general? should we use that instead of GBases?

#7 - 02 Mar 2017 10:57 - John Abbott
- Target version changed from CoCoALib-0.99550 spring 2017 to CoCoALib-0.99560

#8 - 06 Nov 2017 14:09 - John Abbott
- Target version changed from CoCoALib-0.99560 to CoCoALib-0.99600

#9 - 02 Aug 2018 16:04 - Anna Maria Bigatti
- Status changed from New to Resolved

- Target version changed from CoCoALib-0.99600 to CoCoALib-0.99650 November 2019

The fix | did is not bad for that class of examples, and to say it is slow we should make proper comparisons....
postponing again.

#10 - 01 Oct 2019 11:40 - John Abbott
- Target version changed from CoCoALib-0.99650 November 2019 to CoCoALib-0.99700

#11 - 20 Jan 2020 09:27 - John Abbott
- Target version changed from CoCoALib-0.99700 to CoCoALib-0.99800

#12 - 04 Feb 2022 22:23 - John Abbott
- Target version changed from CoCoALib-0.99800 to CoCoALib-0.99850

#13 - 15 May 2023 20:32 - John Abbott

Let P be a poly ring with indets x[1]..x[n] and y[1]..y[m].

Suppose the gens of ideal | involve only x indets. If | want to saturate w.r.t. an irred poly which involves some y indets,

is there a short cut?

In particular, if | saturate w.r.t. y[1] then there is nothing to compute. Presumably the same if | saturate w.r.t. an ideal J which has gens involving only
y indets [!I'm guessing here!].

Are there theoretical results about this? If not, can we prove something.

Orig context: to homogenize an ideal, we can homogenize the gens then saturate w.r.t. the homogenizing indets. Now if the orig polys are already
homogeneous then we will be in the situation described above. Of course, we could also just do IsHomog on each gen... (or compute a RGB then
IsHomog on its elems).

#14 - 16 May 2023 09:24 - John Abbott

My suggestion above is not quite right.
The poly which | am saturating with respect to must be reduced modulo I.

| also note that CoCoALib has a function ContentFreeFactor (or similar name) which computes a factorization based on which indets appear; the
factorization is obtained by repeatedly computing the content (essentially GCD computations).

Anyway, the particular case | had in mind was that the poly "underneath” in the saturation is just a product of indets.
So any indets which do not appear in the gens of | can just be skipped.
#15 - 13 Mar 2024 19:23 - John Abbott
- Related to Feature #1619: Make saturate available in CoCoALib added

#16 - 13 Mar 2024 19:27 - John Abbott
- Related to Bug #1790: saturate with zero ideals added

#17 - 16 Mar 2024 21:24 - John Abbott
- % Done changed from 30 to 70

| have just tried the example from #note-5, and it took just less than 1s on my computer (with v0.99823).
| have increased the %done to 70, since the status is "resolved".

#18 - 21 Mar 2024 17:57 - Anna Maria Bigatti

- Related to deleted (Support #942: Which names to use? Intersection/saturation vs intersect/saturate)

#19 - 21 Mar 2024 18:02 - Anna Maria Bigatti
- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99880

| also added the factorization in the case of a monomial (similar test as in #967-5, now in testOsaturate.cocoab).

Yet to do: saturation for homog ideal: | think | had some code by John | needed to integrate into cocoalib (find it! and its examples).
That will take some work (and will be worth it!). Postponing to next version.

#20 - 22 Mar 2024 10:18 - Anna Maria Bigatti

Different situations to consider (from #1619-8)

e monomial
¢ homog

e principal
e univariate
e general
https://cocoa.dima.unige.it/redmine/issues/967#note-5
